#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>

#define PASS_FILE_PATH "/etc/passwd"

static char *Envnames[3] = {"LOGNAME","USER",NULL};

struct passwd *loguser(char *user)
{
   struct passwd *pwp = NULL;
   int realuid;
   char **ptr;

   realuid=getuid();

    if (user == NULL)
    {
	user = getlogin();
	ptr = Envnames;
	while (pwp == NULL && *ptr != NULL)
	{
	    if (user==NULL ||
	       (pwp=getpwnam(user))==NULL ||
	       pwp->pw_uid!=realuid)
	    {
		user=getenv(*ptr++);
		pwp=NULL;
	    }
	}
	if (pwp == NULL) pwp = getpwuid(realuid);
    }
    else pwp=getpwnam(user);

    if (pwp != NULL && realuid == pwp->pw_uid) return (pwp);
    return(NULL);
}
